function [indice_courant] = FCT_indice_courant_queue()
%function FCT_indice_courant_queue
% Cette fonction permet d'obtenir la valeur du compteur, associ  la queue
% (point par 'pointeur'), correspondant au nombre de commandes excutes
% par le contrleur Dobot.
%
% <- indice_courant : valeur du compteur interne associ  la queue. Le
% compteur est automatiquement incrment quand le controlleur Dobot
% excute une commande.
%
% Rem : La premire variable de sortie de l'API GetQueuedCmdCurrentIndex
% permet de connatre l'tat de fonctionnement de la commande (0 : OK, 1 :
% pb de TimeOut)

% API GetQueuedCmdCurrentIndex p.10 de
% 'Dobot-Magician-API-DescriptionV1.2.3.pdf'
 queue_index=0;   %create queue index
 queue_index_ptr=libpointer('uint64Ptr',queue_index);
 [~, indice_courant]=calllib('DobotDll','GetQueuedCmdCurrentIndex',queue_index_ptr);
end

