% Q_B_3_b_Courbe_mode_Joint.M
% teste si la trajectoire obtenue via '\prog_dobot\Mvt_articulaire_P1_vers_P2.play'
% (rejoignant en mode Joint le point P2  partir du point P1) correspond /(est proche de)
% une trajectoire issue d'une commande base sur une interpolation faite au
% niveau des articulations (en mode Joint dans l'espace articulaire)
% Ce script ncessite la prsence dans le mme rpertoire :
%  + des fichiers Dobot(.dll, .h) : DobotDll.dll , DobotDll.h , DobotType.h ,
%    Qt5Core.dll , Qt5Network.dll , Qt5SerialPort.dll
%  + des fichiers MatLab : FCT_cmd_HOME.m , FCT_cmd_PTP.m , FCT_connecter.m ,
%    FCT_indice_courant_queue.m

clear ALL

setenv('MW_MINGW64_LOC','C:\TDM-GCC-64'); % assigne la valeur 'C:\TDM-GCC-64'
% a la variable d'environnement 'MW_MINGW64_LOC' pour permettre une
% interaction entre MatLab et Dobot

% calcul des points_______________________________________________
Nb_Pts=11; % Nb_Pts = dimension du vecteur articulaire (Nb_Pts doit tre >= 2)
q1=zeros(Nb_Pts,1); q2=zeros(Nb_Pts,1); q3=zeros(Nb_Pts,1);
% calcul par interpolation des vecteurs articulaires  partir des 2 points extrmes de
% la trajectoire
H=-138; % H = d(O_0, niveau du plateau/de la table o repose le robot),
% cf. Figure 1 du TP
P1=[214 -117, H];

%______________________________________________________________
% !! Partie  complter pour permettre le calcul de q1(1), q2(1), q3(1)
%    tant donn P1(1), P1(2), P1(3) !!
%______________________________________________________________

P2=[227, 91, H];

%______________________________________________________________
% !! Partie  complter pour permettre le calcul de q1(Nb_Pts), q2(Nb_Pts), q3(Nb_Pts)
%    tant donn P2(1), P2(2), P2(3) !!
%______________________________________________________________

if Nb_Pts>=3
    for n=2:Nb_Pts-1
        
        %______________________________________________________________
        % !! Partie  complter pour permettre le calcul de q1(n) tant donn
        %    q1(1), q1(Nb_Pts) et Nb_Pts. Faire de mme pour le calcul de
        %    q2(n) et q3(n) !!
        %______________________________________________________________
        
    end

% connexion au robot
FCT_connecter();

% API SetQueuedCmdClear p.10 de 'Dobot-Magician-API-DescriptionV1.2.3.pdf'
calllib('DobotDll','SetQueuedCmdClear');   % clear the command queue
% buffered in the Dobot controller

%cmd start exec queue (excution des commandes mises dans la queue)
calllib('DobotDll','SetQueuedCmdStartExec');  % p.6

% mise dans la queue de la commande HOME (afin d'tre prcis dans les 
% mouvements  venir)
index_Home=FCT_cmd_HOME();

% mise dans la queue des commandes PTP des Nb_Pts points
for i=1:Nb_Pts
  index=FCT_cmd_PTP(q1(i)*180/pi, q2(i)*180/pi, q3(i)*180/pi, 0, 4);
  % test si le buffer interne de la queue du controlleur Dobot n'est pas
  % plein (taille max = 33, on prend 30 par scurit)
    while index-FCT_indice_courant_queue() > 30
      pause(.1)
    end
end

% mise dans la queue de la commande PTP du point correspondant  la configuration
% initiale du robot (q_1 = q_2 = q_3 = 0)
lastIndex=FCT_cmd_PTP(0, 0, 0, 0, 4);
% lastIndex contient le numro de la dernire commande place (SET) dans la queue
% sachant que :
% + le numro du 1er emplacement dans la queue est gale  1,
% + lors de sa mise sous tension, le robot ralise systmatiquement 
% une premire instruction (avec donc un no gale  1 dans la queue).
 
% attente de l'excution de la dernire commande
while lastIndex > FCT_indice_courant_queue()
    pause(.1)
end

%cmd stop exec queue
calllib('DobotDll','SetQueuedCmdStopExec'); % p.6

%cmd disconnect device
calllib('DobotDll','DisconnectDobot'); % p.4

%clear value
clear ptpstruct;
clear ptpstructptr;
clear queue_index_ptr;
%unloadlibrary DobotDll;
